c*********************** BBps *****************************************
c     see files README and COPYING for      Copyright (C) B Bunk 7/1992
c     conditions of use and redistribution                V 2.0  2/2000
c----------------------------------------------------------------------
c     BBplot postscript driver
c         - input : BBplot metafile
c         - output: postscript file
c
      program bbps
c
      parameter(hsmax=210.,vsmax=297.,maxfil=80)
c
      character*(maxfil) metfil,prtfil
      logical rotate
c
c.....metafile format
1000  format(2i4)
1001  format(i8)
c
c     input parameters
c
      call inpar(metfil,prtfil
     &          ,mleft,mright,mtop,lprint,lbase
     &          ,irot,ifeed,lwidth,nfeed,lxaxis,icc)
c
c     printing area
c
      hsize=hsmax - mleft - mright - .2
      vsize=lprint
      mbot=vsmax - mtop - vsize
      if(hsize.lt.20.) goto 901
      if(vsize.lt.20.) goto 902
      if(mbot.lt.0)    goto 903
c
c     open the metafile
c
      open(10,file=metfil,form='FORMATTED',status='OLD',err=910)
      rewind(10)
c
      read(10,1000,end=911) ivers,idummy
      if(ivers .ne. -10  .and.  ivers .ne. -20) goto 912
c
c     metafile coordinate ranges
c
      read(10,1000,end=913) ix0,iy0
      if(ix0 .lt. 0) goto 913
c
      read(10,1000,end=913) ix1,iy1
      if(ix1 .lt. 0) goto 913
c
      read(10,1000,end=913) ixmax,iymax
      if(ixmax .lt. 0) goto 913
      xmin=0.
      xmax=ixmax
      ymin=0.
      ymax=iymax
c
      deltax=xmax-xmin
      deltay=ymax-ymin
      if(deltax .le. 0.) goto 914
      if(deltay .le. 0.) goto 915
      ytox=deltay/deltax
c
      xlen=ix1-ix0
      ylen=iy1-iy0
      if(xlen .le. 0.) goto 916
      if(ylen .le. 0.) goto 917
c
c     determine the plotting area
c
      if(lbase.gt.0 .or. lxaxis.gt.0)then
            xsize=lbase
            if(lxaxis.gt.0) xsize=lxaxis * deltax/xlen
            ysize=xsize*ytox
c
            rotate=irot.eq.1
            if(irot.eq.2)
     &            rotate=xsize.gt.hsize .or. ysize.gt.vsize
c
            if(rotate)then
                  if(xsize.gt.vsize .or. ysize.gt.hsize)goto 920
            else
                  if(xsize.gt.hsize .or. ysize.gt.vsize)goto 920
            endif
      else
            if(irot.eq.0)then
                  rotate=.false.
                  xsize=min(hsize,vsize/ytox)
            else if(irot.eq.1)then
                  rotate=.true.
                  xsize=min(vsize,hsize/ytox)
            else
                  xsize=min(hsize,vsize/ytox)
                  xsrot=min(vsize,hsize/ytox)
                  rotate=xsrot .gt. xsize
                  xsize=max(xsrot,xsize)
            endif
            ysize=xsize*ytox
      endif
c
      if(rotate)then
            skleft=.5*(hsize-ysize) + mleft
            skbot =.5*(vsize-xsize) + mbot
      else
            skleft=.5*(hsize-xsize) + mleft
            skbot =.5*(vsize-ysize) + mbot
      endif
c
c     mappings  metafile -> true -> printer coordinates
c
      sc=72./25.4*xsize/deltax
      if(rotate)then
            shx=72./25.4*skleft - sc*ymin
            shy=72./25.4*skbot  + sc*xmax
      else
            shx=72./25.4*skleft - sc*xmin
            shy=72./25.4*skbot  - sc*ymin
      endif
c
c     bounding box coordinates
c
      if(rotate)then
            illx=shx + sc*ymin      
            iurx=shx + sc*ymax + 1
            illy=shy - sc*xmax
            iury=shy - sc*xmin + 1
      else
            illx=shx + sc*xmin
            iurx=shx + sc*xmax + 1
            illy=shy + sc*ymin
            iury=shy + sc*ymax + 1
      endif
c
c     rescaling of the line width; lwidth=10 => use metafile value
c
      scw=.1*lwidth * sc
c
c     open the printer file -- write header
c
      open(20,file=prtfil,form='FORMATTED',err=930)
c
      write(20,'(a)',err=931) '%!PS-Adobe-1.0'
      write(20,'(2a)',err=931)'%%Title: ',prtfil(1:20)
      write(20,'(a)',err=931) '%%Creator: BBps 2.0 2/2000'
      write(20,'(a,4i4)',err=931) '%%BoundingBox:',illx,illy,iurx,iury
      if(rotate)then
            write(20,'(a)',err=931) '% orientation: landscape'
      else
            write(20,'(a)',err=931) '% orientation: portrait' 
      endif
      if(ifeed.eq.1)
     &      write(20,'(a)',err=931) '% warning: showpage included'
      write(20,'(a)',err=931) 'gsave'
      write(20,'(a)',err=931) 'newpath'
      write(20,'(a)',err=931) '/BBdict 5 dict def'
      write(20,'(a)',err=931) 'BBdict begin'
      write(20,'(a)',err=931) '/W {setlinewidth} def'
      write(20,'(a)',err=931) '/C {setrgbcolor} def'
      write(20,'(a)',err=931) '/M {moveto} def'
      write(20,'(a)',err=931) '/L {lineto} def'
      write(20,'(a)',err=931) '/S {stroke} def'
c
c     translate polygon sequences
c
      iw=0
      irgbo=0
100   continue
      read(10,1000,end=101)ix,iy
c
      if(ix .lt. 0)then
            if(iy.eq.iw)then
                  write(20,'(a)',err=931) 'S'
            else
                  write(20,1050,err=931) scw*iy
1050              format('S',f6.1,' W')
                  iw=iy
            endif
            if(ix .eq. -2)then
                  read(10,1001,end=101)irgb
                  if(irgb .ne. irgbo)then
                        irg=irgb/256
                        ib=irgb - irg*256
                        ir=irg/256
                        ig=irg - ir*256
                        write(20,1060,err=931)ir/255.,ig/255.,ib/255.
1060                    format(f5.3,2f6.3,' C')
                        irgbo=irgb
                  endif
            endif
            read(10,1000,end=101)ix,iy
            if(rotate)then
                  x1=shx + sc*iy
                  y1=shy - sc*ix
            else
                  x1=shx + sc*ix
                  y1=shy + sc*iy
            endif
            write(20,1100,err=931)x1,y1
1100        format(f5.1,f6.1,' M')
            goto 100
      endif
c
      if(rotate)then
            x2=shx + sc*iy
            y2=shy - sc*ix
      else
            x2=shx + sc*ix
            y2=shy + sc*iy
      endif
      write(20,1200,err=931)x2,y2
1200  format(f5.1,f6.1,' L')
c
      x1=x2
      y1=y2
      goto 100
101   continue
      close(10)
      write(20,'(a)',err=931) 'S'
      write(20,'(a)',err=931) 'end'
c
c     print page
c
      if(ifeed.eq.1) write(20,'(a)',err=931) 'showpage'
c
c     reset -- close the printer file
c
      write(20,'(a)',err=931) 'grestore'
      close(20)
c
900   stop 'BBps: all done'
c
901   stop 'BBps error: printing area is too narrow'
902   stop 'BBps error: printing area is too short'
903   stop 'BBps error: printing area is too long'
910   stop 'BBps error: metafile not found'
911   stop 'BBps error: metafile is empty'
912   stop 'BBps error: unknown metafile version'
913   stop 'BBps error: incomplete header in metafile'
914   stop 'BBps error: zero x range in metafile'
915   stop 'BBps error: zero y range in metafile'
916   stop 'BBps error: zero x axis specification in metafile'
917   stop 'BBps error: zero y axis specification in metafile'
920   stop 'BBps error: plot does not fit into printing area'
930   stop 'BBps error: cannot open postscript file'
931   close(20,status='DELETE')
      stop 'BBps error: cannot write postscript file'
c
      end
c-------------------------------------------------------------
c     command line intepreter
c
c     built-in default values:
c     mleft  = 20
c     mright = 20
c     mtop   = 20
c     lprint =250
c     lbase  =  0
c     irot   =  2
c     ifeed  =  1
c     lwidth = 10
c     nfeed  = 48
c     lxaxis =  0
c     icc    =  0
c
      subroutine inpar(metfil,pixfil
     &                ,mleft,mright,mtop,lprint,lbase
     &                ,irot,ifeed,lwidth,nfeed,lxaxis,icc)
c
      character*80  metfil,pixfil
      character*160 line
      dimension ival(11)
      data ival/20,20,20,250,0,2,1,10,48,0,0/
c
      metfil=' '
      pixfil=' '
c
c     scan standard input for parameters and options
c
      npar=0
100   continue
      read(*,'(a)',end=101)line
c
      call decode(line,ikey,newval,i1,i2,npar)
c
      if(ikey.eq.0)then
            goto 100
      else if(ikey.gt.0)then
            ival(ikey)=newval
            if(ikey.eq. 5) ival(10)=0
            if(ikey.eq.10) ival( 5)=0
      else if(ikey.eq.-1)then
            metfil=line(i1:i2)
      else if(ikey.eq.-2)then
            pixfil=line(i1:i2)
      else
c
c           command file encountered
c
            open(40,file=line(i1:i2),status='OLD',err=955)
c
200         continue
            read(40,'(a)',end=201)line
c
            call decode(line,ikey,newval,i1,i2,npar)
c
            if(ikey.eq.0)then
                  goto 200
            else if(ikey.gt.0)then
                  ival(ikey)=newval
                  if(ikey.eq. 5) ival(10)=0
                  if(ikey.eq.10) ival( 5)=0
            else if(ikey.eq.-1)then
                  metfil=line(i1:i2)
            else if(ikey.eq.-2)then
                  pixfil=line(i1:i2)
            else
                  goto 950
            endif
c
            goto 200
c
201         close(40)
c
      endif
c
      goto 100
c
101   continue
      mleft  =ival(1)
      mright =ival(2)
      mtop   =ival(3)
      lprint =ival(4)
      lbase  =ival(5)
      irot   =ival(6)
      ifeed  =ival(7)
      lwidth =ival(8)
      nfeed  =ival(9)
      lxaxis =ival(10)
      icc    =ival(11)
c
      if(metfil.eq.' ') goto 951
      if(pixfil.eq.' ') goto 952
      if(irot.gt.2)     goto 953
      if(ifeed.gt.1)    goto 954
c
      return
c
950   stop 'BBps error: command files cannot be nested'
951   stop 'BBps error: no metafile specified'
952   stop 'BBps error: no printer file specified'
953   stop 'BBps error: illegal value in option ro'
954   stop 'BBps error: illegal value in option ff'
955   print'(3a)',
     &    ' BBps error: command file ',line(i1:i2),' not found'
      stop ' '
      end
c............................................................
c     decode keywords, numerical values, and filenames
c           ikey=0      => line(1:77) or value is blank
c           ikey=1..11  => non-negative integer value in ival
c           ikey=-1..-3 => non-blank filename in line(i1:i2)
c
      subroutine decode(line,ikey,ival,i1,i2,npar)
c
      character*160 line
      character*2   skey(-3:11),ckey(-3:11)
      data skey/'cf','pf','mf','  '
     &         ,'lm','rm','tm','pl','bl','ro','ff','lw','ls','xl','cc'/
      data ckey/'CF','PF','MF','  '
     &         ,'LM','RM','TM','PL','BL','RO','FF','LW','LS','XL','CC'/
c
c     skip leading blanks
c
      do 100 i1=1,77
      if(line(i1:i1).ne.' ')goto 101
100   continue
      ikey=0
      return
101   continue
c
      if(line(i1:i1).eq.'-' .or. line(i1:i1).eq.'/')then
c
c           keyword encountered
c
            i1=i1+1
c
            do 200 ikey=-3,11
            if(ikey.eq.0)goto 200
            if(    line(i1:i1+1).eq.skey(ikey)
     &        .or. line(i1:i1+1).eq.ckey(ikey) )goto 201
200         continue
            goto 960
201         continue
            i1=i1+2
c
      else
c
c           parameter encountered
c
            npar=npar + 1
            if(npar.gt.2)goto 961
            ikey=-npar
c
      endif
c
c     skip leading blanks, colons, and equality signs
c
      j1=i1
      do 300 i1=j1,160
      if( line(i1:i1).ne.' ' .and. line(i1:i1).ne.':'
     &                       .and. line(i1:i1).ne.'=' )goto 301
300   continue
      ikey=0
      return
301   continue
c
      if(ikey.gt.0)then
c
c           return a numerical value
c
            ival=0
            ndig=0
            do 400 i=i1,160
            if(line(i:i).eq.' ') return
            idigit=ichar( line(i:i) ) - 48
            if(idigit.lt.0 .or. idigit.gt.9 .or. ndig.ge.6) goto 962
            ndig=ndig + 1
            ival=10*ival + idigit
400         continue
            goto 962
c
      else
c
c           return a filename
c
            do 410 i2=i1,min(i1+80,159)
            if(line(i2+1:i2+1).eq.' ') return
410         continue
            goto 963
c
      endif
c
960   print'(2a)',' BBps error: unknown option ',line(i1:i1+1)
      stop ' '
961   stop         'BBps error: too many paramters'
962   print'(2a)',' BBps error: illegal value in option ',skey(ikey)
      stop ' '
963   stop         'BBps error: filename is too long'
      end
