c*********************** BBscreen **************************************
c     see files README and COPYING for      Copyright (C) B Bunk 11/1992
c     conditions of use and redistribution                 rev    2/2000
c-----------------------------------------------------------------------
c     BBplot screen display driver
c         - main program, to be linked with the appropriate display
c           module bbdisp.xxx
c         - input: BBplot metafile(s) (filenames in bb_tmp.in)
c
      program bbscrn
c
      parameter(maxfil=81)
c
      character*(maxfil) metfil
c
c.....metafile format
1000  format(2i4)
1001  format(i8)
c
c     read metafile name(s) in bb_tmp.in
c
      open(8,file='bb_tmp.in',form='FORMATTED',status='OLD',err=901)
      rewind(8)
      read(8,'(a)',end=901) metfil
c
1     continue
      if(metfil .eq. ' ') goto 902
      if(metfil(maxfil:maxfil) .ne. ' ') goto 903
c
c     ignore leading and trailing blanks of metfil
c
      i1=0
10    i1=i1 + 1
      if(metfil(i1:i1) .eq. ' ') goto 10
      i2=maxfil
20    i2=i2 - 1
      if(metfil(i2:i2) .eq. ' ') goto 20
c
c     open the metafile -- read header information
c
      open(10,file=metfil(i1:i2),form='FORMATTED',status='OLD',err=910)
      rewind(10)
c
      read(10,1000,end=911) ivers,idummy
      if(ivers .ne. -10  .and.  ivers .ne. -20) goto 912
c
c     metafile coordinate ranges
c
      read(10,1000,end=913) ix0,iy0
      if(ix0 .lt. 0) goto 913
c
      read(10,1000,end=913) ix1,iy1
      if(ix1 .lt. 0) goto 913
c
      read(10,1000,end=913) ixmax,iymax
      if(ixmax .lt. 0) goto 913
c
      if(ixmax .le. 0) goto 914
      if(iymax .le. 0) goto 915
c
c     open the display
c
      call bbopen( 0. , real(ixmax) , 0. , real(iymax) )
c
c     read the metafile and display the plot
c
100   continue
      read(10,1000,end=101)ix,iy
c
      if(ix .lt. 0)then
            call bblwid( real(iy) )
            if(ix .eq. -2)then
                  read(10,1001,end=101)irgb
                  irg=irgb/256
                  ib=irgb - irg*256
                  ir=irg/256
                  ig=irg - ir*256
                  call bbcol(ir,ig,ib)
            endif
c
            read(10,1000,end=101)ix,iy
            call bbmvto( real(ix) , real(iy) )
            goto 100
      endif
c            
      call bblnto( real(ix) , real(iy) )
      goto 100
c
101   continue
      close(10)
c
c     hold the display and terminate it with <crt>
c
      call bbhold(0)
c
c     go to next plot
c
      read(8,'(a)',end=999) metfil
      goto 1
c
999   continue
      close(8)
      stop
c
901   stop 'BBscreen error: metafile(s) not specified'
902   stop 'BBscreen error: metafile name is blank'
903   stop 'BBscreen error: metafile name is too long'
910   print '(3a)',
     &    ' BBscreen error: metafile ',metfil(i1:i2),' not found'
      read(8,'(a)',end=999) metfil
      print '(15x,a)','<crt>...'
      read*
      goto 1
911   stop 'BBscreen error: metafile is empty'
912   stop 'BBscreen error: unknown metafile version'
913   stop 'BBscreen error: incomplete header in metafile'
914   stop 'BBscreen error: zero x range in metafile'
915   stop 'BBscreen error: zero y range in metafile'
      end
