!***************************** bbdraw *********************************
!     see files README and COPYING for      Copyright (C) B Bunk 7/1991
!     conditions of use and redistribution                rev    1/2000
!----------------------------------------------------------------------
!     draw polygons of different (colored) line types

      subroutine bbdraw(n,xpol,ypol,ltypec)

      use bbplot_internal_data

      dimension xpol(*),ypol(*)

      parameter(maxnp=100)
      dimension size(0:3),wlin(0:3),xp(maxnp),yp(maxnp)
      logical draw

      if(n .lt. 2) return

!     extract color index and line type

      icol=ltypec/100
      ltype=ltypec - icol*100

      w=wlin1
      sizdot=1.7*w
      if(ltype.ge.1 .and. ltype.le.4)then
            lt=ltype
      else if(ltype.ge.11 .and. ltype.le.14)then
            w=wlin2
            sizdot=1.4*w
            lt=ltype - 10
      else
            write(6,*) &
              'BBplot error in bbdraw: unknown line type -- reset to 1'
            lt=1
      endif

      if(lt .eq. 1)then
            call bbpoly(n,xpol,ypol,w,icol)
            return
      else if(lt .eq. 2)then
            mcnt=2
            size(0)=sizdsh
            size(1)=sepdsh
            wlin(0)=w
      else if(lt .eq. 3)then
            mcnt=4
            size(0)=sizdsh
            size(1)=sepdot
            size(2)=sizdot
            size(3)=sepdot
            wlin(0)=w
            wlin(2)=sizdot
      else
            mcnt=2
            size(0)=sizdot
            size(1)=sepdot
            wlin(0)=sizdot
      endif

      ind=0
      x1=xpol(1)
      y1=ypol(1)
      s=size(0)
      draw=.true.
      np=1
      xp(1)=x1
      yp(1)=y1

      do 100 i=2,n

      x2=xpol(i)
      y2=ypol(i)
      d12=sqrt( (x1-x2)**2 + (y1-y2)**2 )

110   continue

      if(d12 .lt. s)then
            x1=x2
            y1=y2
            s=s - d12
            if(draw)then
                  np=min( np+1 , maxnp )
                  xp(np)=x1
                  yp(np)=y1
            endif
            goto 100
      endif

      q=s/d12
      x1=x1 + (x2-x1)*q
      y1=y1 + (y2-y1)*q
      d12=d12 - s

      np=min( np+1 , maxnp )
      xp(np)=x1
      yp(np)=y1
      if(draw)then
            call bbpoly(np,xp,yp,wlin(ind),icol)
            np=0
      endif

      draw=.not. draw
      ind=mod( ind+1 , mcnt )
      s=size(ind)
      if(d12 .gt. 0.) goto 110

100   continue

      if(draw) call bbpoly(np,xp,yp,wlin(ind),icol)
      end
