!***************************** bbfmts *****************************
!                                                     B Bunk 7/1991
!     format numbers for labels                       rev   12/2013

      subroutine bbfmt1(z,n1,n2,string)

!     z = m * 10**n1  with integer m and  |z| < 10**(n2+1)

      character(*) string

      logical minus

      if((n2-n1) .gt. 9)then
            write(6,*)'BBplot error in bbfmt1: too many digits'
            string='???'
            return
      endif

      string=' '
      mm=nint( z * 10.**(-n1) )
      i=50

      if(mm.eq.0)then
            string='0'
            return
      endif

!cc      if(n1.le.2 .and. n2.ge.-1)then
      if(n1.le.2 .and. n2.ge.-2)then
! . . . . . . . . . . . . . . . . . . .
!     floating point representation

      minus=mm.lt.0
      mm=abs(mm)
      nn=min(n1,0)
100   continue
      k=0
      if(nn.ge.n1)then
            k=mm - 10*(mm/10)
            mm=mm/10
      endif
      string(i:i)=char(k+48)
      i=i-1
      if(nn.eq.-1)then
            string(i:i)='.'
            i=i-1
      endif
      nn=nn+1
      if(mm.gt.0 .or. nn.le.0) goto 100
      if(minus) string(i-4:i)='"207"'
! . . . . . . . . . . . . . . . . . . .
      else
! . . . . . . . . . . . . . . . . . . .
!     exponential representation

      minus=n2.lt.0
      na=abs(n2)
200   continue
      if(na.gt.0)then
            k=na - 10*(na/10)
            na=na/10
            string(i-1:i)='^'//char(k+48)
            i=i-2
            goto 200
      endif
      if(minus)then
            string(i-5:i)='^"207"'
            i=i-6
      endif
!cc      string(i-6:i)='"189"10'
      string(i-6:i)='"211"10'
      i=i-7

      minus=mm.lt.0
      mm=abs(mm)
      do 210 nn=n1,n2
      k=mm - 10*(mm/10)
      mm=mm/10
      string(i:i)=char(k+48)
      i=i-1
      if(nn .eq. (n2-1))then
            string(i:i)='.'
            i=i-1
      endif
210   continue
      if(minus) string(i-4:i)='"207"'
! . . . . . . . . . . . . . . . . . . .
      endif
      end

! = = = = = = = = = = = = = = = = = = = = = = = = = =

      subroutine bbfmt2(m,n,ifmt,string)

!     z = m * 10**n  with  m=1..9

      character(*) string

      logical minus

      string=' '
      i=50

      if(n.eq.-2 .and. ifmt.eq.2)then
            string(i-3:i)='0.0'//char(m+48)
      else if(n.eq.-1 .and. ifmt.eq.2)then
            string(i-2:i)='0.'//char(m+48)
      else if(n.eq.0)then
            string(i:i)=char(m+48)
      else if(n.eq.1)then
            string(i-1:i)=char(m+48)//'0'
      else if(n.eq.2 .and. ifmt.eq.2)then
            string(i-2:i)=char(m+48)//'00'
      else
            minus=n.lt.0
            na=abs(n)
1100        continue
            if(na.gt.0)then
                  k=na - 10*(na/10)
                  na=na/10
                  string(i-1:i)='^'//char(k+48)
                  i=i-2
                  goto 1100
            endif
            if(minus)then
                  string(i-7:i)='10^"207"'
                  i=i-8
            else
                  string(i-1:i)='10'
                  i=i-2
            endif
            if(m .ne. 1)then
!cc                  string(i-6:i)=char(m+48)//'"189"'
!cc                  i=i-7
                  string(i-5:i)=char(m+48)//'"211"'
                  i=i-6
            endif
      endif
      end
