!***************************** bblabs *********************************
!     see files README and COPYING for      Copyright (C) B Bunk 7/1991
!     conditions of use and redistribution                rev   12/2013
!----------------------------------------------------------------------
!     label the axes
! = = = = = = = = = = = = = = = = = = = = = = =
!     ** x axis **

      subroutine bblabx(xmin,xmax,ymin,ymax,draw)

      use bbplot_internal_data

      parameter(eps10=10.*eps)
      parameter(reduct=.6,sca12=1.+32./21.*reduct)
      parameter(sca1=(9.+16.*reduct)/21.,sca2=(12.+16.*reduct)/21.)
      character(maxlen) string
      logical draw,lab25
      dimension size(5),mult(4),kstep(9)

      xmin=0.
      xmax=1.
      ymin=min(0.,siztkx) - seplbx - sca12*sizlbx
      ymax=max(ytox,ytox-siztkx)

      ylb=ymin + sca1*sizlbx

      if( xlogfl ) goto 500
! - - - - - - - - - - - - - - - - - - - - - - - -
!     x axis -- linear scale

10    continue

      call bbex10( max(abs(xxmin),abs(xxmax)) , ddd , nnn )

      mintst=minlbx
20    continue

      call bbex10( (xxmax-xxmin)/mintst , dd , nn )

      if(dd .ge. 5.)then
            idig=5
      else if(dd .ge. 2.)then
            idig=2
      else
            idig=1
      endif
      delta=idig * 10.**nn
! . . . . . . . .
!     get sizes of numerical labels -- try to avoid overlaps

      xlabs=0.
      xlow=1.
      do 50 n=nint(xxmin/delta),nint(xxmax/delta)
      xx=n*delta
      call bbxx2x(xx,x)
      if(x.lt.-eps10 .or. x.gt.(1.+eps10)) goto 50
      call bbfmt1(xx,nn,nnn,string)
      call bbtext(string,x,ylb,0.,.5,' ',xlen,sizlbx,wrlbx,0)
      xlabs=xlabs + xlen
      xlow=min(xlow,x)
      xhigh=x
50    continue
      xlabs=xlabs - xlen

      if( mintst.gt.2   .and.   xlabs .gt. .8*(xhigh-xlow) )then
            mintst=mintst - 1
            goto 20
      endif
! . . . . . . . .
      mult(1)=1
      size(1)=siztkx
      jdig=idig

      do 100 i=2,4
      dtest=.5*delta
      if(jdig .eq. 5) dtest=.2*delta
      sepmin=septkx
      if(jdig .eq. 1) sepmin=2.*septkx
      stest=xscale*dtest
      if(xlogfl) stest=xscale*log( xxmax/(xxmax-dtest) )
      if(stest .lt. sepmin) goto 101
      delta=dtest
      if(jdig .eq. 5)then
            jdig=1
            m=5
            size(i)=srtkx*size(i-1)
      else if(jdig .eq. 2)then
            jdig=1
            m=2
            size(i)=size(i-1)
      else
            jdig=5
            m=2
            size(i)=srtkx*size(i-1)
      endif
      mult(i)=1
      do 110 j=1,i-1
      mult(j)=m*mult(j)
110   continue
100   continue
101   continue

      do 150 n=nint(xxmin/delta),nint(xxmax/delta)
      xx=n*delta
      call bbxx2x(xx,x)
      if(x.lt.-eps10 .or. x.gt.(1.+eps10)) goto 150
      do 160 j=1,4
      if(mod(n,mult(j)) .eq. 0)then

!     draw ticks of level j

      if(draw)then
            call bbline(x,0.,x,size(j),wtkx,0)
            call bbline(x,ytox,x,ytox-size(j),wtkx,0)
      endif

      if(j.eq.1)then

!           attach a numerical label

            call bbfmt1(xx,nn,nnn,string)
            if(draw)then
               call bbtext(string,x,ylb,0.,.5,'c',xlen,sizlbx,wrlbx,0)
            else
               call bbtext(string,x,ylb,0.,.5,' ',xlen,sizlbx,wrlbx,0)
            endif
            xmin=min(xmin,x - .5*xlen)
            xmax=max(xmax,x + .5*xlen)

      endif

      goto 161
      endif
160   continue
161   continue
150   continue

      return
! - - - - - - - - - - - - - - - - - - - - - - -
!     x axis -- log scale

500   continue

      if( xxmax/xxmin .lt. 5.1 ) goto 10

      call bbex10(xxmin, dd, nn)
      call bbex10(xxmax,ddd,nnn)

      nmult=log10(xxmax/xxmin) / minlbx
      size(1)=siztkx

      if(nmult .ge. 1)then

!           label 10**n only

            lab25=.false.
            ifmt=1

            mstep=9
            if( xscale*.15 .ge. septkx ) mstep=1

            size(2)=size(1)*srtkx
            size(3)=size(2)*srtkx

      else

!           label 1, 2, 5 * 10**n

            nmult=1
            lab25=.true.
            ifmt=2

            mstep=1
            size(2)=size(1)
            size(3)=size(2)
      endif
      size(4)=size(3)*srtkx
      size(5)=size(4)*srtkx

      if(mstep .eq. 9)then
            kstep(1)=10
      else
            kstep(1)=1
            if(xscale*.69 .le. 10.*septkx) kstep(1)=10
            kstep(2)=kstep(1)
            if(xscale*.92 .le. 30.*septkx) kstep(2)=10
            kst=kstep(2)
            do 510 m=3,9
            if(m .eq. 5)then
                  if(xscale*.69 .le. 50.*septkx) kst=10
            endif
            kstep(m)=kst
510         continue
      endif

      do 600 n=nn,nnn

      xx10=10.**n

      do 700 m=1,9,mstep

      xx=m*xx10
      if(xx .gt. (xxmax*1.001)) return
      if(xx .lt. (xxmin*.999))goto 750
      call bbxx2x(xx,x)

      if( ( m.eq.1 .and. mod(n,nmult).eq.0 ) &
            .or. ( lab25 .and. (m.eq.2 .or. m.eq.5) ) )then

!           write a numerical label

            call bbfmt2(m,n,ifmt,string)
            if(draw)then
               call bbtext(string,x,ylb,0.,.5,'c',xlen,sizlbx,wrlbx,0)
            else
               call bbtext(string,x,ylb,0.,.5,' ',xlen,sizlbx,wrlbx,0)
            endif
            xmin=min(xmin,x - .5*xlen)
            xmax=max(xmax,x + .5*xlen)
      endif

750   continue

      do 800 k=0,9,kstep(m)
      xx=(m+.1*k)*xx10
      if(xx .gt. (xxmax*1.001)) return
      if(xx .lt. (xxmin*.999)) goto 800
      call bbxx2x(xx,x)

      if(k.ne.0 .and. k.ne.5)then
            j=5
      else if(k.ne.0)then
            j=4
      else if(m.ne.1 .and. m.ne.5)then
            j=3
      else if(m .ne. 1)then
            j=2
      else
            j=1
      endif

!     draw a tick of level j

      if(draw)then
            call bbline(x,0.,x,size(j),wtkx,0)
            call bbline(x,ytox,x,ytox-size(j),wtkx,0)
      endif

800   continue
700   continue
600   continue

      end
! = = = = = = = = = = = = = = = = = = = = = = =
!      ** y axis **

      subroutine bblaby(xmin,xmax,ymin,ymax,draw)

      use bbplot_internal_data

      parameter(eps10=10.*eps)
      parameter(reduct=.6,sca12=1.+32./21.*reduct)
      parameter(sca1=(9.+16.*reduct)/21.,sca2=(12.+16.*reduct)/21.)
      character(maxlen) string
      logical draw,lab25
      dimension size(5),mult(4),kstep(9)

      xmin0=min(0.,siztky) - seplby
      xmax=max(xmax,1.-siztky)

      if( ylogfl ) goto 1500
! - - - - - - - - - - - - - - - - - - - - - - -
!     y axis -- linear scale

1010  continue

      call bbex10( (yymax-yymin)/minlby , dd , nn )

      if(dd .ge. 5.)then
            idig=5
      else if(dd .ge. 2.)then
            idig=2
      else
            idig=1
      endif

      call bbex10( max(abs(yymin),abs(yymax)) , ddd , nnn )

      mult(1)=1
      size(1)=siztky
      jdig=idig
      delta=idig * 10.**nn

      do 1100 i=2,4
      dtest=.5*delta
      if(jdig .eq. 5) dtest=.2*delta
      sepmin=septky
      if(jdig .eq. 1) sepmin=2.*septky
      stest=yscale*dtest
      if(ylogfl) stest=yscale*log( yymax/(yymax-dtest) )
      if(stest .lt. sepmin) goto 1101
      delta=dtest
      if(jdig .eq. 5)then
            jdig=1
            m=5
            size(i)=srtky*size(i-1)
      else if(jdig .eq. 2)then
            jdig=1
            m=2
            size(i)=size(i-1)
      else
            jdig=5
            m=2
            size(i)=srtky*size(i-1)
      endif
      mult(i)=1
      do 1110 j=1,i-1
      mult(j)=m*mult(j)
1110  continue
1100  continue
1101  continue

      do 1150 n=nint(yymin/delta),nint(yymax/delta)
      yy=n*delta
      call bbyy2y(yy,y)
      if(y.lt.-eps10 .or. y.gt.(ytox+eps10)) goto 1150
      do 1160 j=1,4
      if(mod(n,mult(j)) .eq. 0)then

!     draw ticks of level j

      if(draw)then
            call bbline(0.,y,size(j),y,wtky,0)
            call bbline(1.,y,1.-size(j),y,wtky,0)
      endif

      if(j.eq.1)then

!           attach a numerical label

            call bbfmt1(yy,nn,nnn,string)
            if(draw)then
               call bbtext(string,xmin0,y,0.,.5,'r',xlen,sizlby,wrlby,0)
            else
               call bbtext(string,xmin0,y,0.,.5,' ',xlen,sizlby,wrlby,0)
            endif
            xmin=min(xmin,xmin0 - xlen)
            ymin=min(ymin,y - sca1*sizlby)
            ymax=max(ymax,y + sca2*sizlby)

      endif

      goto 1161
      endif
1160  continue
1161  continue
1150  continue

      return
! - - - - - - - - - - - - - - - - - - - - - - - -
!     y axis -- log scale

1500  continue

      if( yymax/yymin .lt. 5.1 ) goto 1010

      call bbex10(yymin, dd, nn)
      call bbex10(yymax,ddd,nnn)

      nmult=log10(yymax/yymin) / minlby
      size(1)=siztky

      if(nmult .ge. 1)then

!           label 10**n only

            lab25=.false.
            ifmt=1

            mstep=9
            if( yscale*.15 .ge. septky ) mstep=1

            size(2)=size(1)*srtky
            size(3)=size(2)*srtky

      else

!           label 1, 2, 5 * 10**n

            nmult=1
            lab25=.true.
            ifmt=2

            mstep=1
            size(2)=size(1)
            size(3)=size(2)
      endif
      size(4)=size(3)*srtky
      size(5)=size(4)*srtky

      if(mstep .eq. 9)then
            kstep(1)=10
      else
            kstep(1)=1
            if(yscale*.69 .le. 10.*septky) kstep(1)=10
            kstep(2)=kstep(1)
            if(yscale*.92 .le. 30.*septky) kstep(2)=10
            kst=kstep(2)
            do 1510 m=3,9
            if(m .eq. 5)then
                  if(yscale*.69 .le. 50.*septky) kst=10
            endif
            kstep(m)=kst
1510        continue
      endif

      do 1600 n=nn,nnn

      yy10=10.**n

      do 1700 m=1,9,mstep

      yy=m*yy10
      if(yy .gt. (yymax*1.001)) return
      if(yy .lt. (yymin*.999))goto 1750
      call bbyy2y(yy,y)

      if( ( m.eq.1 .and. mod(n,nmult).eq.0 ) &
            .or. ( lab25 .and. (m.eq.2 .or. m.eq.5) ) )then

!           write a numerical label

            call bbfmt2(m,n,ifmt,string)
            if(draw)then
               call bbtext(string,xmin0,y,0.,.5,'r',xlen,sizlby,wrlby,0)
            else
               call bbtext(string,xmin0,y,0.,.5,' ',xlen,sizlby,wrlby,0)
            endif
            xmin=min(xmin,xmin0 - xlen)
            ymin=min(ymin,y - sca1*sizlby)
            ymax=max(ymax,y + sca2*sizlby)
      endif

1750  continue

      do 1800 k=0,9,kstep(m)
      yy=(m+.1*k)*yy10
      if(yy .gt. (yymax*1.001)) return
      if(yy .lt. (yymin*.999)) goto 1800
      call bbyy2y(yy,y)

      if(k.ne.0 .and. k.ne.5)then
            j=5
      else if(k.ne.0)then
            j=4
      else if(m.ne.1 .and. m.ne.5)then
            j=3
      else if(m .ne. 1)then
            j=2
      else
            j=1
      endif

!     draw a tick of level j

      if(draw)then
            call bbline(0.,y,size(j),y,wtky,0)
            call bbline(1.,y,1.-size(j),y,wtky,0)
      endif

1800  continue
1700  continue
1600  continue
      end
