!***************************** bbsave *********************************
!     see files README and COPYING for      Copyright (C) B Bunk 2/2000
!     conditions of use and redistribution                rev   12/2013
!----------------------------------------------------------------------
!     save plot data to file -- restore

      subroutine save_plot(fname)

      use bbplot_internal_data

      character(*) fname

      logical opened

      if(fname .eq. ' ') return
      if(len(fname) .lt. 1) return

!     ignore leading and trailing blanks of fname
!     determine output unit

      call bbtrim(fname,i1,i2)

      iunit=6
10    continue
      iunit=iunit + 1
      if(iunit.gt.99) goto 911
      inquire(iunit,opened=opened)
      if(opened) goto 10

      open(iunit,file=fname(i1:i2),err=912)
      rewind(iunit)

      write(iunit,'(a)',err=920)'BBplot-2.2'

      write(iunit,'(a)',err=920)'*** Parameters ***'
      write(iunit,*,err=920) &
                  ytox,wframe &
                  ,septkx,siztkx,srtkx,wtkx,minlbx,seplbx,sizlbx,wrlbx &
                  ,seplgx,sizlgx,wrlgx &
                  ,septky,siztky,srtky,wtky,minlby,seplby,sizlby,wrlby &
                  ,seplgy,sizlgy,wrlgy &
                  ,radpt,wrpt,wbar,robarx,robary &
                  ,ninter,wlin1,wlin2,sizdsh,sepdsh,sepdot &
                  ,septit,siztit,wrtit,sepsub,sizsub,wrsub &
                  ,xlgpos,ylgpos,sizfld,sepfld,seplg,sizlg,wrlg &
                  ,siztxt,wrtxt

      write(iunit,'(a)',err=920)'*** RGB palette ***'
      write(iunit,*,err=920) &
            maxcol,' = max. color index;   (R * 256 + G ) * 256 + B ='
      write(iunit,*,err=920)(irgb(i),i=0,maxcol)

      write(iunit,'(a)',err=920)'*** Data points ***'
      write(iunit,*,err=920)npts,' = #points'
      do 100 i=1,npts
100   write(iunit,*,err=920)xdat(i),dxdat(i),ydat(i),dydat(i),isyms(i)

      write(iunit,'(a)',err=920)'*** Functions ***'
      write(iunit,*,err=920)nfcts,' = #functions'
      do 110 i=1,nfcts
110   write(iunit,*,err=920)ifcts(i),xxf1(i),xxf2(i),ltypes(i),cutfl(i)

      write(iunit,'(a)',err=920)'*** Joint polygon storage ***'
      write(iunit,*,err=920)npols,' = #polygon points'
      do 120 i=1,npols
120   write(iunit,*,err=920)xpols(i),ypols(i),ltpols(i)

      write(iunit,'(a)',err=920)'*** Text insertions ***'
      write(iunit,*,err=920)ntxts,' = #insertions'
      do 130 i=1,ntxts
      write(iunit,*,err=920)xtxts(i),ytxts(i),ictxts(i)
      call bbtrim(strngs(itxts(i)),i1,i2)
      write(iunit,'(a)',err=920)strngs(itxts(i))(i1:max(i1,i2))
130   continue

      write(iunit,'(a)',err=920)'*** Legend for points and lines ***'
      write(iunit,*,err=920)nlegs,' = #legend entries'
      do 140 i=1,nlegs
      write(iunit,*,err=920)legs(i)
      call bbtrim(strngs(ilegs(i)),i1,i2)
      write(iunit,'(a)',err=920)strngs(ilegs(i))(i1:max(i1,i2))
140   continue

      write(iunit,'(a)',err=920)'*** X/Y axis ***'
      write(iunit,*,err=920)xrmin,xrmax,xlogfl,' = x range, log flag'
      write(iunit,*,err=920)yrmin,yrmax,ylogfl,' = y range, log flag'
      write(iunit,*,err=920)ytoxin,' = y/x input'
      write(iunit,*,err=920)iso,' = isoscale flag'
      write(iunit,*,err=920)xlbfl,ylbfl,' = label flags; x/y legends:'
      call bbtrim(xstrng,i1,i2)
      write(iunit,'(a)',err=920)xstrng(i1:max(i1,i2))
      call bbtrim(ystrng,i1,i2)
      write(iunit,'(a)',err=920)ystrng(i1:max(i1,i2))

      write(iunit,'(a)',err=920)'*** Titles ***'
      write(iunit,*,err=920)ntits,' = #lines'
      do 150 i=1,ntits
      call bbtrim(strngs(itits(i)),i1,i2)
      write(iunit,'(a)',err=920)strngs(itits(i))(i1:max(i1,i2))
150   continue

      write(iunit,'(a)',err=920)'*** Sub-titles ***'
      write(iunit,*,err=920)nsubs,' = #lines'
      do 160 i=1,nsubs
      call bbtrim(strngs(isubs(i)),i1,i2)
      write(iunit,'(a)',err=920)strngs(isubs(i))(i1:max(i1,i2))
160   continue

      close(iunit)
      return

900   format(' BBplot error in save_plot: ',a:1x,a)
911   write(6,900)'too many open files'
      stop
912   write(6,900)'cannot open',fname(i1:i2)
      return
920   write(6,900)'write error in',fname(i1:i2)
      close(iunit,status='DELETE')
      end
! - - - - - - - - - - - - - - - - - - - - - - - - - -
      subroutine read_plot(fname)

      use bbplot_internal_data

      character(*) fname

      logical opened
      character(10) string

      if(fname .eq. ' ') return
      if(len(fname) .lt. 1) return

!     ignore leading and trailing blanks of fname
!     determine output unit

      call bbtrim(fname,i1,i2)

      iunit=6
510   continue
      iunit=iunit + 1
      if(iunit.gt.99) goto 961
      inquire(iunit,opened=opened)
      if(opened) goto 510

      open(iunit,file=fname(i1:i2),status='OLD',err=962)
      rewind(iunit)

      read(iunit,'(a)',err=970,end=971)string
      if(string .ne. 'BBplot-2.2') goto 963

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971) &
                  ytox,wframe &
                  ,septkx,siztkx,srtkx,wtkx,minlbx,seplbx,sizlbx,wrlbx &
                  ,seplgx,sizlgx,wrlgx &
                  ,septky,siztky,srtky,wtky,minlby,seplby,sizlby,wrlby &
                  ,seplgy,sizlgy,wrlgy &
                  ,radpt,wrpt,wbar,robarx,robary &
                  ,ninter,wlin1,wlin2,sizdsh,sepdsh,sepdot &
                  ,septit,siztit,wrtit,sepsub,sizsub,wrsub &
                  ,xlgpos,ylgpos,sizfld,sepfld,seplg,sizlg,wrlg &
                  ,siztxt,wrtxt

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)maxc
      if(maxc.gt.maxcol) goto 980
      read(iunit,*,err=970,end=971)(irgb(i),i=0,maxc)
      do 550 i=maxc+1,maxcol
      irgb(i)=0
550   continue

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)npts
      if(npts .gt. maxpts)then
         call bbrealloc_pts(npts, ierr)
         if (ierr /= 0) goto 981
      endif
      do 600 i=1,npts
600   read(iunit,*,err=970,end=971) &
            xdat(i),dxdat(i),ydat(i),dydat(i),isyms(i)

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)nfcts
      if(nfcts .gt. maxfct)then
         call bbrealloc_fct(nfcts, ierr)
         if (ierr /= 0) goto 982
      endif
      do 610 i=1,nfcts
610   read(iunit,*,err=970,end=971) &
            ifcts(i),xxf1(i),xxf2(i),ltypes(i),cutfl(i)

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)npols
      if(npols .gt. maxpol)then
         call bbrealloc_pol(npols, ierr)
         if (ierr /= 0) goto 983
      endif
      do 620 i=1,npols
620   read(iunit,*,err=970,end=971)xpols(i),ypols(i),ltpols(i)

      nstrgs=0

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)ntxts
      if((nstrgs+ntxts) .gt. maxstr)then
         call bbrealloc_str(nstrgs+ntxts, ierr)
         if (ierr /= 0) goto 984
      endif   
      do 630 i=1,ntxts
      read(iunit,*,err=970,end=971)xtxts(i),ytxts(i),ictxts(i)
      nstrgs=nstrgs + 1
      itxts(i)=nstrgs
      read(iunit,'(a)',err=970,end=971)strngs(nstrgs)
630   continue

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)nlegs
      if((nstrgs+nlegs) .gt. maxstr)then
         call bbrealloc_str(nstrgs+nlegs, ierr)
         if (ierr /= 0) goto 984
      endif   
      do 640 i=1,nlegs
      read(iunit,*,err=970,end=971)legs(i)
      nstrgs=nstrgs + 1
      ilegs(i)=nstrgs
      read(iunit,'(a)',err=970,end=971)strngs(nstrgs)
640   continue

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)xrmin,xrmax,xlogfl
      read(iunit,*,err=970,end=971)yrmin,yrmax,ylogfl
      read(iunit,*,err=970,end=971)ytoxin
      read(iunit,*,err=970,end=971)iso
      read(iunit,*,err=970,end=971)xlbfl,ylbfl
      read(iunit,'(a)',err=970,end=971)xstrng
      read(iunit,'(a)',err=970,end=971)ystrng

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)ntits
      if((nstrgs+ntits) .gt. maxstr)then
         call bbrealloc_str(nstrgs+ntits, ierr)
         if (ierr /= 0) goto 984
      endif
      do 650 i=1,ntits
      nstrgs=nstrgs + 1
      itits(i)=nstrgs
      read(iunit,'(a)',err=970,end=971)strngs(nstrgs)
650   continue

      read(iunit,*,err=970,end=971)
      read(iunit,*,err=970,end=971)nsubs
      if((nstrgs+nsubs) .gt. maxstr)then
         call bbrealloc_str(nstrgs+nsubs, ierr)
         if (ierr /= 0) goto 984
      endif   
      do 660 i=1,nsubs
      nstrgs=nstrgs + 1
      isubs(i)=nstrgs
      read(iunit,'(a)',err=970,end=971)strngs(nstrgs)
660   continue

      close(iunit)

      return

950   format(' BBplot error in read_plot: ',a:1x,a)
961   write(6,950)'too many open files'
      stop
962   write(6,950)'cannot open',fname(i1:i2)
      return
963   write(6,950)'invalid input file',fname(i1:i2)
      close(iunit)
      return
970   write(6,950)'read error in',fname(i1:i2)
      close(iunit)
      return
971   write(6,950)'unexpected end of file in',fname(i1:i2)
      close(iunit)
      return
980   write(6,950)'too many colors'
      stop
981   write(6,950)'too many points'
      stop
982   write(6,950)'too many functions'
      stop
983   write(6,950)'too many polygon points'
      stop
984   write(6,950)'too many strings'
      stop
      end
