!***************************** bbspl ******************************
!                                                     B Bunk 3/1992
!     cubic spline interpolation of x(i),y(i),i=1..n  rev   12/2013
!           - natural boundary conditions
!           - y range is restricted to 0..ytox

      subroutine bbspl(n,x,y,ltype,ninter,ytox)

      dimension x(*),y(*)
      dimension y2(n),u(n),xp(ninter+1),yp(ninter+1)

      if(n.lt.2) return
      inter=ninter

!     compute the cubic spline

      y2(1)=0.
      u(1)=0.
      do 10 i=2,n-1
      sig=(x(i)-x(i-1))/(x(i+1)-x(i-1))
      p=sig*y2(i-1)+2.
      y2(i)=(sig-1.)/p
      u(i)=(6.*((y(i+1)-y(i))/(x(i+1)-x(i))-(y(i)-y(i-1)) &
          /(x(i)-x(i-1)))/(x(i+1)-x(i-1))-sig*u(i-1))/p
10    continue
      y2(n)=0.
      do 20 i=n-1,1,-1
      y2(i)=y2(i)*y2(i+1)+u(i)
20    continue

!     compute and draw the interpolating polygon

      xstep=(x(n)-x(1))/inter
      xpp=x(1)
      k=1
      h=x(2)-x(1)
      do 100 i=1,inter+1
110   continue
      a=(x(k+1)-xpp)/h
      if(a.lt.0. .and. k.lt.(n-1))then
            k=k+1
            h=x(k+1)-x(k)
            goto 110
      endif
      b=1.-a
      xp(i)=xpp
      yp(i)=a*y(k)+b*y(k+1)+ &
              ((a**3-a)*y2(k)+(b**3-b)*y2(k+1))*(h**2)/6.
      yp(i)=min( max( yp(i) , 0. ) , ytox )
      xpp=xpp + xstep
100   continue
      call bbdraw(inter+1,xp,yp,ltype)
      end
