!***************************** iniplt *********************************
!     see files README and COPYING for      Copyright (C) B Bunk 7/1991
!     conditions of use and redistribution                rev   12/2013
!----------------------------------------------------------------------
!     initialise the plot: clear counters
!                          set defaults
      subroutine iniplt

      use bbplot_internal_data

!     coordinate system

!.....y/x aspect ratio of the coordinate box [1]
      ytox=1.
!.....y/x input and isoscale flag
      ytoxin=1.
      iso=0
!.....x range and log flag
      xrmin=-huge
      xrmax= huge
      xlogfl=.false.
!.....y range and log flag
      yrmin=-huge
      yrmax= huge
      ylogfl=.false.
!.....line width for frame [2]
      wframe=.003

!     x axis

!.....label flag
      xlbfl=.true.
!.....ticks [3..6]
      septkx=.0095
      siztkx=.03
      srtkx=.65
      wtkx=.002
!.....labels [7..10]
      minlbx=3
      seplbx=.01
      sizlbx=.03
      wrlbx=.075
!.....legend text
      xstrng=' '
!.....legend separation and letter size [11..13]
      seplgx=.01
      sizlgx=.03
      wrlgx=.075

!     y axis

!.....label flag
      ylbfl=.true.
!.....ticks [14..17]
      septky=.0095
      siztky=.03
      srtky=.65
      wtky=.002
!.....labels [18..21]
      minlby=3
      seplby=.01
      sizlby=.03
      wrlby=.075
!.....legend text
      ystrng=' '
!.....legend separation and letter size [22..24]
      seplgy=.01
      sizlgy=.03
      wrlgy=.075

!     points

!.....counter
      npts=0
!.....size (radius) and relative line width for symbols [25,26]
      radpt=.01
      wrpt=.060
!.....line width and rotation parameters for error bars [27..29]
      wbar=.0020
      robarx=.3
      robary=.3

!     functions

!.....counter
      nfcts=0
!.....discretisation intervals [30]
      ninter=100
!.....cut flags
      do 10 i=1,maxfct
      cutfl(i)=.false.
10    continue

!     polygons and splines

!.....counter
      npols=0

!     lines for functions, polygons, and splines

!.....line width and style [31..35]
      wlin1=.0020
      wlin2=.0030
      sizdsh=.02
      sepdsh=.011
      sepdot=.009

!     titles

!.....counter
      ntits=0
!.....line separation and letter size [36..38]
      septit=.015
      siztit=.035
      wrtit=.075

!     sub-titles

!.....counter
      nsubs=0
!.....line separation and letter size [39..41]
      sepsub=.012
      sizsub=.030
      wrsub=.075

!     legend for point symbols and line types

!.....counter
      nlegs=0
!.....position [42,43]
      xlgpos=0.
      ylgpos=0.
!.....symbol field size and separation [44,45]
      sizfld=.07
      sepfld=.01
!.....line seperation and letter size [46..48]
      seplg=.01
      sizlg=.025
      wrlg=.075

!     text insertions

!.....counter
      ntxts=0
!.....letter size [49,50]
      siztxt=.025
      wrtxt=.075

!.....shared string storage -- counter
      nstrgs=0

!     color map (palette)

      do 20 i=0,maxcol
      irgb(i)=0
20    continue
      irgb(1)=irgb1
      irgb(2)=irgb2
      irgb(3)=irgb3
      irgb(4)=irgb4
      irgb(5)=irgb5
      irgb(6)=irgb6
      irgb(7)=irgb7

!     detach mode of display window

      idet=0
      end
! = = = = = = = = = = = = = = = = = = = = = = =
!     set the y/x aspect ratio

      subroutine aspect(y2x)

      use bbplot_internal_data

      if(y2x .gt. 0.)then
         ytoxin=y2x
      else
         write(6,*)'BBplot error in aspect: invalid argument -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     set the isoscale flag

      subroutine isoscale(iso1)

      use bbplot_internal_data

      if(iso1 .ge. 0 .and. iso1 .le. 2)then
            iso=iso1
      else
         write(6,*)'BBplot error in isoscale: invalid flag -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     log scale in x

      subroutine logx

      use bbplot_internal_data

      xlogfl=.true.
      end

      subroutine xlog
      call logx
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     log scale in y

      subroutine logy

      use bbplot_internal_data

      ylogfl=.true.
      end

      subroutine ylog
      call logy
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     linear scale in x

      subroutine linx

      use bbplot_internal_data

      xlogfl=.false.
      end

      subroutine xlin
      call linx
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     linear scale in y

      subroutine liny

      use bbplot_internal_data

      ylogfl=.false.
      end

      subroutine ylin
      call liny
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     set x range

      subroutine xrange(x1,x2)

      use bbplot_internal_data

      if(x1 .ne. x2)then
            xrmin=min(x1,x2)
            xrmax=max(x1,x2)

            xrmin=xrmin - abs(xrmin)*eps
            xrmax=xrmax + abs(xrmax)*eps
      else
            write(6,*)'BBplot error in xrange: zero range -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     set y range

      subroutine yrange(y1,y2)

      use bbplot_internal_data

      if(y1 .ne. y2)then
            yrmin=min(y1,y2)
            yrmax=max(y1,y2)

            yrmin=yrmin - abs(yrmin)*eps
            yrmax=yrmax + abs(yrmax)*eps
      else
            write(6,*)'BBplot error in yrange: zero range -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     cut function in x and y

      subroutine cutfct(ifct)

      use bbplot_internal_data

      ncuts=0
      do 100 i=1,nfcts
      if(ifcts(i) .eq. ifct)then
            cutfl(i)=.true.
            ncuts=ncuts + 1
      endif
100   continue
      if(ncuts .eq. 0) &
         write(6,*)'BBplot error in cutfct: unknown ifct -- ignored'
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     set the legend position

      subroutine legpos(x,y)

      use bbplot_internal_data

      xlgpos=x
      ylgpos=y
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     disable x labels

      subroutine nolabx

      use bbplot_internal_data

      xlbfl=.false.
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     disable y labels

      subroutine nolaby

      use bbplot_internal_data

      ylbfl=.false.
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     rescale all letter sizes

      subroutine letsiz(scfact)

      use bbplot_internal_data

      if(scfact .gt. 0.)then
            sizlbx=scfact*sizlbx
            sizlby=scfact*sizlby
            sizlgx=scfact*sizlgx
            sizlgy=scfact*sizlgy
            siztit=scfact*siztit
            sizsub=scfact*sizsub
            sizlg=scfact*sizlg
            siztxt=scfact*siztxt
      else
            write(6,*) &
              'BBplot error in letsiz: invalid scale factor -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     rescale the sizes of point symbols

      subroutine symsiz(scfact)

      use bbplot_internal_data

      if(scfact .gt. 0.)then
            radpt=scfact*radpt
      else
            write(6,*) &
              'BBplot error in symsiz: invalid scale factor -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     rescale all line widths

      subroutine linwid(scfact)

      use bbplot_internal_data

      if(scfact .ge. 0.)then
            wframe=scfact*wframe
            wtkx=scfact*wtkx
            wtky=scfact*wtky
            wrlbx=scfact*wrlbx
            wrlby=scfact*wrlby
            wrlgx=scfact*wrlgx
            wrlgy=scfact*wrlgy
            wrpt=scfact*wrpt
            wbar=scfact*wbar
            wlin1=scfact*wlin1
            wlin2=scfact*wlin2
            wrtit=scfact*wrtit
            wrsub=scfact*wrsub
            wrlg=scfact*wrlg
            wrtxt=scfact*wrtxt
      else
            write(6,*) &
              'BBplot error in linwid: invalid scale factor -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     rescale x and y tick marks

      subroutine tcksiz(scfact)

      use bbplot_internal_data

      siztkx=scfact*siztkx
      siztky=scfact*siztky

      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     redefine color

      subroutine setcol(icol,ir,ig,ib)

      use bbplot_internal_data

      if(icol .ge. 0.  .and.  icol .le. maxcol)then
            irgb(icol) = (min(max(ir,0),255) * 256 &
                        + min(max(ig,0),255)) * 256 &
                        + min(max(ib,0),255)
      else
            write(6,*) &
              'BBplot error in setcol: index out of range -- ignored'
      endif
      end
! - - - - - - - - - - - - - - - - - - - - - - -
!     set detach mode for display window

      subroutine detach(idet1)

      use bbplot_internal_data

      idet=0
      if(idet1 .ne. 0) idet=1
      end
